diff --git a/lib/sink_iface.h b/lib/sink_iface.h
index 39aabc7..f28e88b 100644
--- a/lib/sink_iface.h
+++ b/lib/sink_iface.h
@@ -25,344 +25,14 @@
 #include <osmosdr/time_spec.h>
 #include <gnuradio/basic_block.h>
 
+#include "common_iface.h"
+
 /*!
  * TODO: document
  *
  */
-class sink_iface
+class sink_iface : public common_iface
 {
-public:
-  /*!
-   * Get the number of channels the underlying radio hardware offers.
-   * \return the number of available channels
-   */
-  virtual size_t get_num_channels( void ) = 0;
-
-  /*!
-   * Get the possible sample rates for the underlying radio hardware.
-   * \return a range of rates in Sps
-   */
-  virtual osmosdr::meta_range_t get_sample_rates( void ) = 0;
-
-  /*!
-   * Set the sample rate for the underlying radio hardware.
-   * This also will select the appropriate IF bandpass, if applicable.
-   * \param rate a new rate in Sps
-   */
-  virtual double set_sample_rate( double rate ) = 0;
-
-  /*!
-   * Get the sample rate for the underlying radio hardware.
-   * This is the actual sample rate and may differ from the rate set.
-   * \return the actual rate in Sps
-   */
-  virtual double get_sample_rate( void ) = 0;
-
-  /*!
-   * Get the tunable frequency range for the underlying radio hardware.
-   * \param chan the channel index 0 to N-1
-   * \return the frequency range in Hz
-   */
-  virtual osmosdr::freq_range_t get_freq_range( size_t chan = 0 ) = 0;
-
-  /*!
-   * Tune the underlying radio hardware to the desired center frequency.
-   * This also will select the appropriate RF bandpass.
-   * \param freq the desired frequency in Hz
-   * \param chan the channel index 0 to N-1
-   * \return the actual frequency in Hz
-   */
-  virtual double set_center_freq( double freq, size_t chan = 0 ) = 0;
-
-  /*!
-   * Get the center frequency the underlying radio hardware is tuned to.
-   * This is the actual frequency and may differ from the frequency set.
-   * \param chan the channel index 0 to N-1
-   * \return the frequency in Hz
-   */
-  virtual double get_center_freq( size_t chan = 0 ) = 0;
-
-  /*!
-   * Set the frequency correction value in parts per million.
-   * \param ppm the desired correction value in parts per million
-   * \param chan the channel index 0 to N-1
-   * \return correction value in parts per million
-   */
-  virtual double set_freq_corr( double ppm, size_t chan = 0 ) = 0;
-
-  /*!
-   * Get the frequency correction value.
-   * \param chan the channel index 0 to N-1
-   * \return correction value in parts per million
-   */
-  virtual double get_freq_corr( size_t chan = 0 ) = 0;
-
-  /*!
-   * Get the gain stage names of the underlying radio hardware.
-   * \param chan the channel index 0 to N-1
-   * \return a vector of strings containing the names of gain stages
-   */
-  virtual std::vector<std::string> get_gain_names( size_t chan = 0 ) = 0;
-
-  /*!
-   * Get the settable overall gain range for the underlying radio hardware.
-   * \param chan the channel index 0 to N-1
-   * \return the gain range in dB
-   */
-  virtual osmosdr::gain_range_t get_gain_range( size_t chan = 0 ) = 0;
-
-  /*!
-   * Get the settable gain range for a specific gain stage.
-   * \param name the name of the gain stage
-   * \param chan the channel index 0 to N-1
-   * \return the gain range in dB
-   */
-  virtual osmosdr::gain_range_t get_gain_range( const std::string & name,
-                                                size_t chan = 0 ) = 0;
-
-  /*!
-   * Set the gain mode for the underlying radio hardware.
-   * This might be supported only for certain hardware types.
-   * \param automatic the gain mode (true means automatic gain mode)
-   * \param chan the channel index 0 to N-1
-   * \return the actual gain mode
-   */
-  virtual bool set_gain_mode( bool automatic, size_t chan = 0 ) { return false; }
-
-  /*!
-   * Get the gain mode selected for the underlying radio hardware.
-   * \param chan the channel index 0 to N-1
-   * \return the actual gain mode (true means automatic gain mode)
-   */
-  virtual bool get_gain_mode( size_t chan = 0 ) { return false; }
-
-  /*!
-   * Set the gain for the underlying radio hardware.
-   * This function will automatically distribute the desired gain value over
-   * available gain stages in an appropriate way and return the actual value.
-   * \param gain the gain in dB
-   * \param chan the channel index 0 to N-1
-   * \return the actual gain in dB
-   */
-  virtual double set_gain( double gain, size_t chan = 0 ) = 0;
-
-  /*!
-   * Set the named gain on the underlying radio hardware.
-   * \param gain the gain in dB
-   * \param name the name of the gain stage
-   * \param chan the channel index 0 to N-1
-   * \return the actual gain in dB
-   */
-  virtual double set_gain( double gain,
-                           const std::string & name,
-                           size_t chan = 0 ) = 0;
-
-  /*!
-   * Get the actual gain setting of the underlying radio hardware.
-   * \param chan the channel index 0 to N-1
-   * \return the actual gain in dB
-   */
-  virtual double get_gain( size_t chan = 0 ) = 0;
-
-  /*!
-   * Get the actual gain setting of a named stage.
-   * \param name the name of the gain stage
-   * \param chan the channel index 0 to N-1
-   * \return the actual gain in dB
-   */
-  virtual double get_gain( const std::string & name, size_t chan = 0 ) = 0;
-
-  /*!
-   * Set the IF gain for the underlying radio hardware.
-   * This function will automatically distribute the desired gain value over
-   * available IF gain stages in an appropriate way and return the actual value.
-   * \param gain the gain in dB
-   * \param chan the channel index 0 to N-1
-   * \return the actual gain in dB
-   */
-  virtual double set_if_gain( double gain, size_t chan = 0 ) { return 0; }
-
-  /*!
-   * Set the BB gain for the underlying radio hardware.
-   * This function will automatically distribute the desired gain value over
-   * available BB gain stages in an appropriate way and return the actual value.
-   * \param gain the gain in dB
-   * \param chan the channel index 0 to N-1
-   * \return the actual gain in dB
-   */
-  virtual double set_bb_gain( double gain, size_t chan = 0 ) { return 0; }
-
-  /*!
-   * Get the available antennas of the underlying radio hardware.
-   * \param chan the channel index 0 to N-1
-   * \return a vector of strings containing the names of available antennas
-   */
-  virtual std::vector< std::string > get_antennas( size_t chan = 0 ) = 0;
-
-  /*!
-   * Select the active antenna of the underlying radio hardware.
-   * \param chan the channel index 0 to N-1
-   * \return the actual antenna's name
-   */
-  virtual std::string set_antenna( const std::string & antenna,
-                                   size_t chan = 0 ) = 0;
-
-  /*!
-   * Get the actual underlying radio hardware antenna setting.
-   * \param chan the channel index 0 to N-1
-   * \return the actual antenna's name
-   */
-  virtual std::string get_antenna( size_t chan = 0 ) = 0;
-
-  /*!
-   * Set the TX frontend DC offset value.
-   * The value is complex to control both I and Q.
-   *
-   * \param offset the dc offset (1.0 is full-scale)
-   * \param chan the channel index 0 to N-1
-   */
-  virtual void set_dc_offset( const std::complex<double> &offset, size_t chan = 0 ) { }
-
-  /*!
-   * Set the TX frontend IQ balance correction.
-   * Use this to adjust the magnitude and phase of I and Q.
-   *
-   * \param balance the complex correction value
-   * \param chan the channel index 0 to N-1
-   */
-  virtual void set_iq_balance( const std::complex<double> &balance, size_t chan = 0 ) { }
-
-  /*!
-   * Set the bandpass filter on the radio frontend.
-   * \param bandwidth the filter bandwidth in Hz, set to 0 for automatic selection
-   * \param chan the channel index 0 to N-1
-   * \return the actual filter bandwidth in Hz
-   */
-  virtual double set_bandwidth( double bandwidth, size_t chan = 0 ) { return 0; }
-
-  /*!
-   * Get the actual bandpass filter setting on the radio frontend.
-   * \param chan the channel index 0 to N-1
-   * \return the actual filter bandwidth in Hz
-   */
-  virtual double get_bandwidth( size_t chan = 0 ) { return 0; }
-
-  /*!
-   * Get the possible bandpass filter settings on the radio frontend.
-   * \param chan the channel index 0 to N-1
-   * \return a range of bandwidths in Hz
-   */
-  virtual osmosdr::freq_range_t get_bandwidth_range( size_t chan = 0 )
-    { return osmosdr::freq_range_t(); }
-
-  /*!
-   * Set the time source for the device.
-   * This sets the method of time synchronization,
-   * typically a pulse per second or an encoded time.
-   * Typical options for source: external, MIMO.
-   * \param source a string representing the time source
-   * \param mboard which motherboard to set the config
-   */
-  virtual void set_time_source(const std::string &source,
-                               const size_t mboard = 0) { }
-
-  /*!
-   * Get the currently set time source.
-   * \param mboard which motherboard to get the config
-   * \return the string representing the time source
-   */
-  virtual std::string get_time_source(const size_t mboard) { return ""; }
-
-  /*!
-   * Get a list of possible time sources.
-   * \param mboard which motherboard to get the list
-   * \return a vector of strings for possible settings
-   */
-  virtual std::vector<std::string> get_time_sources(const size_t mboard)
-  {
-    return std::vector<std::string>();
-  }
-
-  /*!
-   * Set the clock source for the device.
-   * This sets the source for a 10 Mhz reference clock.
-   * Typical options for source: internal, external, MIMO.
-   * \param source a string representing the clock source
-   * \param mboard which motherboard to set the config
-   */
-  virtual void set_clock_source(const std::string &source,
-                                const size_t mboard = 0) { }
-
-  /*!
-   * Get the currently set clock source.
-   * \param mboard which motherboard to get the config
-   * \return the string representing the clock source
-   */
-  virtual std::string get_clock_source(const size_t mboard) { return ""; }
-
-  /*!
-   * Get a list of possible clock sources.
-   * \param mboard which motherboard to get the list
-   * \return a vector of strings for possible settings
-   */
-  virtual std::vector<std::string> get_clock_sources(const size_t mboard)
-  {
-    return std::vector<std::string>();
-  }
-
-  /*!
-   * Get the master clock rate.
-   * \param mboard the motherboard index 0 to M-1
-   * \return the clock rate in Hz
-   */
-  virtual double get_clock_rate(size_t mboard = 0) { return 0; }
-
-  /*!
-   * Set the master clock rate.
-   * \param rate the new rate in Hz
-   * \param mboard the motherboard index 0 to M-1
-   */
-  virtual void set_clock_rate(double rate, size_t mboard = 0) { }
-
-  /*!
-   * Get the current time registers.
-   * \param mboard the motherboard index 0 to M-1
-   * \return the current device time
-   */
-  virtual ::osmosdr::time_spec_t get_time_now(size_t mboard = 0)
-  {
-    return ::osmosdr::time_spec_t::get_system_time();
-  }
-
-  /*!
-   * Get the time when the last pps pulse occured.
-   * \param mboard the motherboard index 0 to M-1
-   * \return the current device time
-   */
-  virtual ::osmosdr::time_spec_t get_time_last_pps(size_t mboard = 0)
-  {
-    return ::osmosdr::time_spec_t::get_system_time();
-  }
-
-  /*!
-   * Sets the time registers immediately.
-   * \param time_spec the new time
-   * \param mboard the motherboard index 0 to M-1
-   */
-  virtual void set_time_now(const ::osmosdr::time_spec_t &time_spec,
-                            size_t mboard = 0) { }
-
-  /*!
-   * Set the time registers at the next pps.
-   * \param time_spec the new time
-   */
-  virtual void set_time_next_pps(const ::osmosdr::time_spec_t &time_spec) { }
-
-  /*!
-   * Sync the time registers with an unknown pps edge.
-   * \param time_spec the new time
-   */
-  virtual void set_time_unknown_pps(const ::osmosdr::time_spec_t &time_spec) { }
 };
 
 #endif // OSMOSDR_SINK_IFACE_H
diff --git a/lib/sink_impl.cc b/lib/sink_impl.cc
index 285638b..cb0588a 100644
--- a/lib/sink_impl.cc
+++ b/lib/sink_impl.cc
@@ -78,11 +78,14 @@ sink_impl::sink_impl( const std::string &args )
   : gr::hier_block2 ("sink_impl",
         args_to_io_signature(args),
         gr::io_signature::make(0, 0, 0)),
-    _sample_rate(NAN)
+    _manager(make_dev_manager(to_hier_block2()))
 {
   size_t channel = 0;
   bool device_specified = false;
 
+  message_port_register_hier_in( osmosdr::CMD_PORT );
+  msg_connect( self(), osmosdr::CMD_PORT, _manager, osmosdr::CMD_PORT );
+
   std::vector< std::string > arg_list = args_to_vector(args);
 
   std::vector< std::string > dev_types;
@@ -224,18 +227,10 @@ sink_impl::sink_impl( const std::string &args )
     }
 #endif
 
-    if ( iface != NULL && long(block.get()) != 0 ) {
-      _devs.push_back( iface );
-
-      for (size_t i = 0; i < iface->get_num_channels(); i++) {
-        connect(self(), channel++, block, i);
-      }
-    } else if ( (iface != NULL) || (long(block.get()) != 0) )
-      throw std::runtime_error("Either iface or block are NULL.");
-
+    _manager->add_device( block, iface );
   }
 
-  if (!_devs.size())
+  if (!_manager->get_num_mboards())
     throw std::runtime_error("No devices specified via device arguments.");
 #ifdef WORKAROUND_GR_HIER_BLOCK2_BUG
   } catch ( std::exception &ex ) {
@@ -270,448 +265,205 @@ sink_impl::sink_impl( const std::string &args )
 
 size_t sink_impl::get_num_channels()
 {
-  size_t channels = 0;
-
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    channels += dev->get_num_channels();
-
-  return channels;
+  return _manager->get_num_channels();
 }
 
-#define NO_DEVICES_MSG  "FATAL: No device(s) available to work with."
-
 osmosdr::meta_range_t sink_impl::get_sample_rates()
 {
-  if ( ! _devs.empty() )
-    return _devs[0]->get_sample_rates(); // assume same devices used in the group
-#if 0
-  else
-    throw std::runtime_error(NO_DEVICES_MSG);
-#endif
-  return osmosdr::meta_range_t();
+  return _manager->get_sample_rates();
 }
 
-double sink_impl::set_sample_rate(double rate)
+double sink_impl::set_sample_rate( double rate )
 {
-  double sample_rate = 0;
-
-  if (_sample_rate != rate) {
-#if 0
-    if (_devs.empty())
-      throw std::runtime_error(NO_DEVICES_MSG);
-#endif
-    BOOST_FOREACH( sink_iface *dev, _devs )
-      sample_rate = dev->set_sample_rate(rate);
-
-    _sample_rate = sample_rate;
-  }
-
-  return sample_rate;
+  return _manager->set_sample_rate( rate );
 }
 
 double sink_impl::get_sample_rate()
 {
-  double sample_rate = 0;
-
-  if (!_devs.empty())
-    sample_rate = _devs[0]->get_sample_rate(); // assume same devices used in the group
-#if 0
-  else
-    throw std::runtime_error(NO_DEVICES_MSG);
-#endif
-  return sample_rate;
+  return _manager->get_sample_rate();
 }
 
 osmosdr::freq_range_t sink_impl::get_freq_range( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_freq_range( dev_chan );
-
-  return osmosdr::freq_range_t();
+  return _manager->get_freq_range( chan );
 }
 
 double sink_impl::set_center_freq( double freq, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _center_freq[ chan ] != freq ) {
-          _center_freq[ chan ] = freq;
-          return dev->set_center_freq( freq, dev_chan );
-        } else { return _center_freq[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_center_freq( freq, chan );
 }
 
 double sink_impl::get_center_freq( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_center_freq( dev_chan );
-
-  return 0;
+  return _manager->get_center_freq( chan );
 }
 
 double sink_impl::set_freq_corr( double ppm, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _freq_corr[ chan ] != ppm ) {
-          _freq_corr[ chan ] = ppm;
-          return dev->set_freq_corr( ppm, dev_chan );
-        } else { return _freq_corr[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_freq_corr( ppm, chan );
 }
 
 double sink_impl::get_freq_corr( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_freq_corr( dev_chan );
-
-  return 0;
+  return _manager->get_freq_corr( chan );
 }
 
 std::vector<std::string> sink_impl::get_gain_names( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain_names( dev_chan );
-
-  return std::vector< std::string >();
+  return _manager->get_gain_names( chan );
 }
 
 osmosdr::gain_range_t sink_impl::get_gain_range( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain_range( dev_chan );
-
-  return osmosdr::gain_range_t();
+  return _manager->get_gain_range( chan );
 }
 
 osmosdr::gain_range_t sink_impl::get_gain_range( const std::string & name, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain_range( name, dev_chan );
-
-  return osmosdr::gain_range_t();
+  return _manager->get_gain_range( name, chan );
 }
 
 bool sink_impl::set_gain_mode( bool automatic, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _gain_mode[ chan ] != automatic ) {
-          _gain_mode[ chan ] = automatic;
-          bool mode = dev->set_gain_mode( automatic, dev_chan );
-          if (!automatic) // reapply gain value when switched to manual mode
-            dev->set_gain( _gain[ chan ], dev_chan );
-          return mode;
-        } else { return _gain_mode[ chan ]; }
-      }
-
-  return false;
+  return _manager->set_gain_mode( automatic, chan );
 }
 
 bool sink_impl::get_gain_mode( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain_mode( dev_chan );
-
-  return false;
+  return _manager->get_gain_mode( chan );
 }
 
 double sink_impl::set_gain( double gain, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _gain[ chan ] != gain ) {
-          _gain[ chan ] = gain;
-          return dev->set_gain( gain, dev_chan );
-        } else { return _gain[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_gain( gain, chan );
 }
 
 double sink_impl::set_gain( double gain, const std::string & name, size_t chan)
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->set_gain( gain, name, dev_chan );
-
-  return 0;
+  return _manager->set_gain( gain, name, chan );
 }
 
 double sink_impl::get_gain( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain( dev_chan );
-
-  return 0;
+  return _manager->get_gain( chan );
 }
 
 double sink_impl::get_gain( const std::string & name, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_gain( name, dev_chan );
-
-  return 0;
+  return _manager->get_gain( name, chan );
 }
 
 double sink_impl::set_if_gain( double gain, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _if_gain[ chan ] != gain ) {
-          _if_gain[ chan ] = gain;
-          return dev->set_if_gain( gain, dev_chan );
-        } else { return _if_gain[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_if_gain( gain, chan );
 }
 
 double sink_impl::set_bb_gain( double gain, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _bb_gain[ chan ] != gain ) {
-          _bb_gain[ chan ] = gain;
-          return dev->set_bb_gain( gain, dev_chan );
-        } else { return _bb_gain[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_bb_gain( gain, chan );
 }
 
 std::vector< std::string > sink_impl::get_antennas( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_antennas( dev_chan );
-
-  return std::vector< std::string >();
+  return _manager->get_antennas( chan );
 }
 
 std::string sink_impl::set_antenna( const std::string & antenna, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _antenna[ chan ] != antenna ) {
-          _antenna[ chan ] = antenna;
-          return dev->set_antenna( antenna, dev_chan );
-        } else { return _antenna[ chan ]; }
-      }
-
-  return "";
+  return _manager->set_antenna( antenna, chan );
 }
 
 std::string sink_impl::get_antenna( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_antenna( dev_chan );
-
-  return "";
+  return _manager->get_antenna( chan );
 }
 
 void sink_impl::set_dc_offset( const std::complex<double> &offset, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        dev->set_dc_offset( offset, dev_chan );
+  _manager->set_dc_offset( offset, chan );
 }
 
 void sink_impl::set_iq_balance( const std::complex<double> &balance, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        dev->set_iq_balance( balance, dev_chan );
+  _manager->set_iq_balance( balance, chan );
 }
 
 double sink_impl::set_bandwidth( double bandwidth, size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ ) {
-        if ( _bandwidth[ chan ] != bandwidth || 0.0f == bandwidth ) {
-          _bandwidth[ chan ] = bandwidth;
-          return dev->set_bandwidth( bandwidth, dev_chan );
-        } else { return _bandwidth[ chan ]; }
-      }
-
-  return 0;
+  return _manager->set_bandwidth( bandwidth, chan );
 }
 
 double sink_impl::get_bandwidth( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_bandwidth( dev_chan );
-
-  return 0;
+  return _manager->get_bandwidth( chan );
 }
 
 osmosdr::freq_range_t sink_impl::get_bandwidth_range( size_t chan )
 {
-  size_t channel = 0;
-  BOOST_FOREACH( sink_iface *dev, _devs )
-    for (size_t dev_chan = 0; dev_chan < dev->get_num_channels(); dev_chan++)
-      if ( chan == channel++ )
-        return dev->get_bandwidth_range( dev_chan );
-
-  return osmosdr::freq_range_t();
+  return _manager->get_bandwidth_range( chan );
 }
 
-void sink_impl::set_time_source(const std::string &source, const size_t mboard)
+void sink_impl::set_time_source( const std::string &source, const size_t mboard )
 {
-  if (mboard != osmosdr::ALL_MBOARDS){
-      _devs.at(mboard)->set_time_source( source );
-      return;
-  }
-
-  for (size_t m = 0; m < _devs.size(); m++){ /* propagate ALL_MBOARDS */
-      _devs.at(m)->set_time_source( source, osmosdr::ALL_MBOARDS );
-  }
+  return _manager->set_time_source( source, mboard );
 }
 
-std::string sink_impl::get_time_source(const size_t mboard)
+std::string sink_impl::get_time_source( const size_t mboard )
 {
-  return _devs.at(mboard)->get_time_source( mboard );
+  return _manager->get_time_source( mboard );
 }
 
-std::vector<std::string> sink_impl::get_time_sources(const size_t mboard)
+std::vector<std::string> sink_impl::get_time_sources( const size_t mboard )
 {
-  return _devs.at(mboard)->get_time_sources( mboard );
+  return _manager->get_time_sources( mboard );
 }
 
-void sink_impl::set_clock_source(const std::string &source, const size_t mboard)
+void sink_impl::set_clock_source( const std::string &source, const size_t mboard )
 {
-  if (mboard != osmosdr::ALL_MBOARDS){
-      _devs.at(mboard)->set_clock_source( source );
-      return;
-  }
-
-  for (size_t m = 0; m < _devs.size(); m++){ /* propagate ALL_MBOARDS */
-      _devs.at(m)->set_clock_source( source, osmosdr::ALL_MBOARDS );
-  }
+  return _manager->set_clock_source( source, mboard );
 }
 
-std::string sink_impl::get_clock_source(const size_t mboard)
+std::string sink_impl::get_clock_source( const size_t mboard )
 {
-  return _devs.at(mboard)->get_clock_source( mboard );
+  return _manager->get_clock_source( mboard );
 }
 
-std::vector<std::string> sink_impl::get_clock_sources(const size_t mboard)
+std::vector<std::string> sink_impl::get_clock_sources( const size_t mboard )
 {
-  return _devs.at(mboard)->get_clock_sources( mboard );
+  return _manager->get_clock_sources( mboard );
 }
 
-double sink_impl::get_clock_rate(size_t mboard)
+double sink_impl::get_clock_rate( size_t mboard )
 {
-  return _devs.at(mboard)->get_clock_rate( mboard );
+  return _manager->get_clock_rate( mboard );
 }
 
-void sink_impl::set_clock_rate(double rate, size_t mboard)
+void sink_impl::set_clock_rate( double rate, size_t mboard )
 {
-  if (mboard != osmosdr::ALL_MBOARDS){
-      _devs.at(mboard)->set_clock_rate( rate );
-      return;
-  }
-
-  for (size_t m = 0; m < _devs.size(); m++){ /* propagate ALL_MBOARDS */
-      _devs.at(m)->set_clock_rate( rate, osmosdr::ALL_MBOARDS );
-  }
+  return _manager->set_clock_rate( rate, mboard );
 }
 
-osmosdr::time_spec_t sink_impl::get_time_now(size_t mboard)
+osmosdr::time_spec_t sink_impl::get_time_now( size_t mboard )
 {
-  return _devs.at(mboard)->get_time_now( mboard );
+  return _manager->get_time_now( mboard );
 }
 
-osmosdr::time_spec_t sink_impl::get_time_last_pps(size_t mboard)
+osmosdr::time_spec_t sink_impl::get_time_last_pps( size_t mboard )
 {
-  return _devs.at(mboard)->get_time_last_pps( mboard );
+  return _manager->get_time_last_pps( mboard );
 }
 
-void sink_impl::set_time_now(const osmosdr::time_spec_t &time_spec, size_t mboard)
+void sink_impl::set_time_now( const osmosdr::time_spec_t &time_spec, size_t mboard )
 {
-  if (mboard != osmosdr::ALL_MBOARDS){
-      _devs.at(mboard)->set_time_now( time_spec );
-      return;
-  }
-
-  for (size_t m = 0; m < _devs.size(); m++){ /* propagate ALL_MBOARDS */
-      _devs.at(m)->set_time_now( time_spec, osmosdr::ALL_MBOARDS );
-  }
+  return _manager->set_time_now( time_spec, mboard );
 }
 
-void sink_impl::set_time_next_pps(const osmosdr::time_spec_t &time_spec)
+void sink_impl::set_time_next_pps( const osmosdr::time_spec_t &time_spec )
 {
-  BOOST_FOREACH( sink_iface *dev, _devs )
-  {
-    dev->set_time_next_pps( time_spec );
-  }
+  return _manager->set_time_next_pps( time_spec );
 }
 
-void sink_impl::set_time_unknown_pps(const osmosdr::time_spec_t &time_spec)
+void sink_impl::set_time_unknown_pps( const osmosdr::time_spec_t &time_spec )
 {
-  BOOST_FOREACH( sink_iface *dev, _devs )
-  {
-    dev->set_time_unknown_pps( time_spec );
-  }
+  return _manager->set_time_unknown_pps( time_spec );
 }
diff --git a/lib/sink_impl.h b/lib/sink_impl.h
index 1642669..a4589b5 100644
--- a/lib/sink_impl.h
+++ b/lib/sink_impl.h
@@ -22,7 +22,7 @@
 
 #include "osmosdr/sink.h"
 
-#include "sink_iface.h"
+#include "dev_manager.h"
 
 #include <map>
 
@@ -83,18 +83,7 @@ public:
   void set_time_unknown_pps(const ::osmosdr::time_spec_t &time_spec);
 
 private:
-  std::vector< sink_iface * > _devs;
-
-  /* cache to prevent multiple device calls with the same value coming from grc */
-  double _sample_rate;
-  std::map< size_t, double > _center_freq;
-  std::map< size_t, double > _freq_corr;
-  std::map< size_t, bool > _gain_mode;
-  std::map< size_t, double > _gain;
-  std::map< size_t, double > _if_gain;
-  std::map< size_t, double > _bb_gain;
-  std::map< size_t, std::string > _antenna;
-  std::map< size_t, double > _bandwidth;
+  dev_manager_sptr _manager;
 };
 
 #endif /* INCLUDED_OSMOSDR_SINK_IMPL_H */
